<template>
  <v-card flat class="d-flex flex-column" style="min-height: 100vh">
    <template v-if="properties.length && !loading">
      <property-card v-for="item in properties" :key="item.id" :value="item" />
      <v-pagination
        v-model="page"
        class="mb-5"
        :length="totalPages"
        total-visible="10"
        color="accent"
      />
    </template>
    <template v-else-if="loading">
      <v-card v-for="i in 15" :key="i" class="mb-3" outlined tile>
        <v-skeleton-loader
          type="card-heading"
        />
        <div :class="{ 'd-flex': true, 'flex-column': !isDesktop }">
          <v-skeleton-loader
            class="flex-grow-1"
            type="image"
            height="160"
          />
          <v-skeleton-loader
            :width="isDesktop ? '50%' : '100%'"
            height="160"
            type="list-item-three-line, actions"
          />
        </div>
      </v-card>
    </template>
    <v-overlay v-show="isMoving && isDesktop" :value="isMoving" class="overlay-moving">
      <div class="d-flex flex-column align-center">
        <div class="hand-moving">
          <v-icon size="60" color="white">
            {{ mdiHandRight }}
          </v-icon>
        </div>
        <h3 class="display-2 mt-5 pt-5">
          Moving
        </h3>
      </div>
    </v-overlay>
  </v-card>
</template>

<script lang="ts">
import { mdiHandRight } from '@mdi/js'
import { defineComponent, computed, onMounted, ref } from '@vue/composition-api'
import { useQuery } from '../hooks'
import PropertyCard from '@/components/PropertyCard.vue'

export default defineComponent({
  components: { PropertyCard },
  props: {
    isMoving: Boolean
  },
  setup (_, context) {
    const { properties, location } = useQuery(context)
    const loading = computed<boolean>(() => context.root.$store.state.properties.loading)
    const count = computed<number>(() => context.root.$store.state.properties.count)

    const page = computed({
      get: () => context.root.$store.state.properties.currentPage,
      set: (v) => {
        context.root.$router.push({
          ...location.value,
          query: {
            ...location.value.query,
            page: String(v)
          }
        })
        context.root.$store.dispatch('properties/changePage', v)
      }
    })
    const totalPages = computed(() => Math.ceil(count.value / 15))
    const isDesktop = ref(true)
    onMounted(() => {
      isDesktop.value = context.root.$vuetify.breakpoint?.mdAndUp ?? true
    })
    return { properties, page, loading, totalPages, mdiHandRight, isDesktop }
  }
})
</script>

<style>
.overlay-moving {
  position: sticky !important;
  top: 96px;
  height: calc(100vh - 96px);
}
.hand-moving {
  margin-right: 50%;
  transform-origin: 100% center;
  animation: rotate 4s linear infinite;
}
.hand-moving > * {
  animation: rotate 4s linear reverse infinite;
}
@keyframes rotate {
  100% {
    transform: rotate(360deg);
  }
}
</style>
